#ifndef IST_DSO_SETUP_H
#define IST_DSO_SETUP_H


#if defined(_DSO) && !defined(_STATIC)
	#ifdef _WIN32
		#define DSO_EXPORT __declspec(dllexport)
		#define DSO_CLASS __declspec(dllexport)
	#else
		#define DSO_EXPORT extern "C"
		#define DSO_CLASS
	#endif
#else
	#if defined(_WIN32) && !defined(_STATIC)
		#define DSO_EXPORT
		#define DSO_CLASS
	#else
		#define DSO_EXPORT
		#define DSO_CLASS
	#endif
#endif

#ifdef _WIN32
	#define EXPORT extern "C" __declspec(dllexport)
	#define EXPORT_CLASS __declspec(dllexport)
	#define DECLARE_DSO_ENTRYPOINT()\
BOOL WINAPI DllEntryPoint(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)\
{\
	return TRUE;\
}
#else
	#define EXPORT extern "C"
	#define EXPORT_CLASS
	#define DECLARE_DSO_ENTRYPOINT()
#endif

#endif
