#include <set>
#include <fstream>
#include <sstream>
#include "ist/ist_net.h"
#include "ist/ist_sys.h"



class extracter : public ist::IGZExtracter
{
public:
	extracter(ist::bstream& bf) : ist::IGZExtracter(bf) {}
	virtual bool extractBuffer(const std::string& filename, ist::bbuffer& out) {
		bool res = false;
		if(res = ist::IGZExtracter::extractBuffer(filename, out))
			printf("%s\n", filename.c_str());
		else
			printf("failed %s\n", filename.c_str());
		return res;
	}
};



std::string patch_url;
std::set<std::string> patch_list;


bool patch(const std::string& filename) {
	printf("patch: %s\n", filename.c_str());

	ist::HTTP h;
	h.get(patch_url+filename);
	if(!!h) {
		extracter igz(h.getContent());
		igz.extractAllFiles();
	}
	else {
		printf("%s ̃_E[hɎs܂BT[o[ŃAzȃ~X炩Ă܂܂B\n");
		return false;
	}
	return true;
}

void script() {
	std::fstream f("patchscript", std::ios::in | std::ios::binary);
	if(!!f) {
		std::string l;
		char command[32], filename[128];
		while(std::getline(f, l)) {
			printf("script: %s\n", l.c_str());
			if(sscanf(l.c_str(), "%s %[^\r]", command, filename)==2) {
				if(strcmp(command, "rm")==0)
					ist::Remove(filename);
				else if(strcmp(command, "exec")==0)
					system(filename);
			}
		}
		f.close();
		ist::Remove("patchscript");
	}
}

int main()
{
	gimite::startup_socket();

	{
		std::fstream f("patchconf", std::ios::in | std::ios::binary);
		std::string l;
		if(!!f && std::getline(f, l))
			patch_url = l;
		if(!patch_url.empty() && patch_url[patch_url.size()-1]=='\n')
			patch_url.erase(patch_url.end()-1);
		if(!patch_url.empty() && patch_url[patch_url.size()-1]=='\r')
			patch_url.erase(patch_url.end()-1);
	}

	{
		std::fstream f("patch", std::ios::in | std::ios::binary);
		std::string l;
		while(!!f && std::getline(f, l))
			patch_list.insert(l);
	}

	ist::HTTP h;
	h.get(patch_url+"patch");
	if(!!h) {
		std::stringstream ss(h.getContent().str());
		std::string l;
		while(std::getline(ss, l)) {
			if(patch_list.find(l)==patch_list.end() && patch(l)) {
				patch_list.insert(l);
			}
		}
		script();
	}
	else {
		printf("pb`Xg̎擾Ɏs܂B\n");
	}

	{
		std::fstream f("patch", std::ios::out | std::ios::binary);
		for(std::set<std::string>::iterator p=patch_list.begin(); p!=patch_list.end(); ++p) {
			f << *p;
		}
	}
	printf("pb`Ƃ܂BQ[N܂B\n");

	system("empire_tohu.exe");

	gimite::cleanup_socket();
}

