#!/bin/bash


. ../../conf.sh

if [ ! $OUTDIR ]; then
	OUTDIR="../../.."
fi

if [ $CXX = "g++" ]; then
	CFLAGS="$CFLAGS -s"
fi

if test $# -ne 0; then
	SRCS=`echo $@ | grep -E \.\(cc\|cpp\)`
else
	SRCS=`ls | grep -E \.\(cc\|cpp\)`
fi

for f in $SRCS; do
	$CXX -c $f -I ../../ $CFLAGS
done

$CXX $OBJS $LIBS -o $OUTDIR/tohu_ruler.dso $LFLAGS $SHARED_FLAG
