#!/bin/sh

TARGET=ist.lib
CC=cl
#CFLAGS="/nologo /MT /O2 /Og /Ob2 /Ot /GX /GA /D_MBCS /FD /GS /DWIN32 /DNDEBUG /DDSO_BUILD $CFLAGS"
CFLAGS="/nologo /MT /O2 /Og /Ob2 /Ot /GX /GA /D_MBCS /FD /GS /DWIN32 /DNDEBUG /D_STATIC $CFLAGS"
LIBS="/link opengl32.lib glu32.lib zlib.lib libpng.lib libjpeg.lib"

if test $# -ne 0
then
	srcs=`echo $@ | grep -E \.\(cc\|cpp\)`
else
#	rm *.obj
	srcs=`ls | grep -E \.\(cc\|cpp\)`
fi

for f in ${srcs}
do
	${CC} /c ${CFLAGS} ${EXTFLAGS} ${f}
done


echo $TARGET
lib -out:${TARGET} *.obj
#${CC} /LD /o ist.dll *.obj ${LIBS}

