//---------------------------------------------------------------------------
//
// Name:        configDlg.h
// Author:      i-saint
// Created:     2005/08/15 12:21:08
//
//---------------------------------------------------------------------------
#ifndef __configDlg_HPP_
#define __configDlg_HPP_

#include <wx/wxprec.h>
#ifdef __BORLANDC__
        #pragma hdrstop
#endif
#ifndef WX_PRECOMP
        #include <wx/wx.h>
#endif

//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
#include <wx/gauge.h>
#include <wx/button.h>
#include <wx/radiobut.h>
#include <wx/checkbox.h>
#include <wx/textctrl.h>
#include <wx/stattext.h>
#include <wx/statbox.h>
////Header Include End

#include <wx/dialog.h>

////Dialog Style Start
	#undef configDlg_STYLE
	#define configDlg_STYLE wxCAPTION | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxCLOSE_BOX
////Dialog Style End

class configDlg : public wxDialog
{
public:
    configDlg( wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("config1"),
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = configDlg_STYLE);
    virtual ~configDlg();
public:
  //Do not add custom Control Declarations here.
  //wx-devcpp will remove them. Try adding the custom code 
  //after the block.
  ////GUI Control Declaration Start
	wxGauge *G_patch;
	wxTextCtrl *TC_patch_status;
	wxStaticText *WxStaticText2;
	wxTextCtrl *ED_server_address;
	wxTextCtrl *ED_port;
	wxStaticText *WxStaticText1;
	wxButton *BUOK;
	wxTextCtrl *ED_server_port;
	wxTextCtrl *ED_server_database;
	wxTextCtrl *ED_font;
	wxRadioButton *RB_res1280;
	wxRadioButton *RB_res1024;
	wxRadioButton *RB_res800;
	wxCheckBox *CB_no_effect;
	wxCheckBox *CB_frame_skip;
	wxCheckBox *CB_full_screen;
	wxTextCtrl *ED_player_name;
	wxStaticText *WxStaticText6;
	wxStaticText *WxStaticText5;
	wxStaticText *WxStaticText4;
	wxStaticText *WxStaticText3;
	wxStaticBox *WxStaticBox3;
	wxStaticBox *WxStaticBox2;
	wxStaticBox *WxStaticBox1;
  ////GUI Control Declaration End
public:

    //Note: if you receive any error with these enums, then you need to
    //change your old form code that are based on the #define control ids.
    //#defines may replace a numeric value for the enums names.
    //Try copy pasting the below block in your old Form header Files.
	enum {
////GUI Enum Control ID Start
ID_G_PATCH = 1034,
ID_TC_PATCH_STATUS = 1033,
ID_WXSTATICTEXT2 = 1031,
ID_WXEDIT2 = 1032,
ID_ED_PORT = 1028,
ID_WXSTATICTEXT1 = 1029,
ID_WXBUTTON1 = 1008,
ID_ED_SERVER_PORT = 1019,
ID_ED_SERVER_DATABASE = 1013,
ID_ED_FONT = 1024,
ID_RB_RES1280 = 1026,
ID_RB_RES1024 = 1006,
ID_RB_RES800 = 1005,
ID_CB_NO_EFFECT = 1025,
ID_CB_FRAME_SKIP = 1004,
ID_CB_FULL_SCREEN = 1003,
ID_ED_PLAYER_NAME = 1007,
ID_WXSTATICTEXT6 = 1023,
ID_WXSTATICTEXT5 = 1022,
ID_WXSTATICTEXT4 = 1021,
ID_WXSTATICTEXT3 = 1020,
ID_WXSTATICBOX3 = 1012,
ID_WXSTATICBOX2 = 1011,
ID_WXSTATICBOX1 = 1010,
////GUI Enum Control ID End
   ID_DUMMY_VALUE_ //Dont Delete this DummyValue
   }; //End of Enum
private:
    DECLARE_EVENT_TABLE()

public:
    void configDlgClose(wxCloseEvent& event);
    void CreateGUIControls(void);
	void BUOKClick(wxCommandEvent& event);
	void saveConfig(const char *filename);
};

#endif
 
 
 
 
