#!/bin/bash


. ../conf.sh

if [ ! $OUTDIR ]; then
	OUTDIR="../../"
fi

if [ $CXX = "cl" ]; then
	LIBS="SDL_mixer.lib $LIBS"
else
	CFLAGS="$CFLAGS -s"
	LIBS="-lSDL_mixer $LIBS"
fi


if test $# -ne 0; then
	SRCS=`echo $@ | grep -E \.\(cc\|cpp\)`
else
	SRCS=`ls | grep -E \.\(cc\|cpp\)`
fi

for f in $SRCS; do
	$CXX -c $f -I ../ $CFLAGS
done

$CXX $OBJS $LIBS -o $OUTDIR/sound.dso $LFLAGS $SHARED_FLAG
