#!/bin/bash


. ../conf.sh


if [ $CXX = "cl" ]; then
#	rc icon.rc
#	OBJS="*.obj *.res"
	OBJS="*.obj"
else
	CFLAGS="$CFLAGS -rdynamic"
	LIBS="-ldl -lGL -lGLU -lGLEW -llua -llualib -lpng `sdl-config --libs` -Wl,--whole-archive libist.a -Wl,--no-whole-archive"
fi

if [ ! $OUTDIR ]; then
	OUTDIR="../.."
fi
OUTFILE=$OUTDIR/empire_tohu

if test $# -ne 0; then
	SRCS=`echo $@ | grep -E \.\(cc\|cpp\)`
else
	SRCS=`ls | grep -E \.\(cc\|cpp\)`
fi

for f in $SRCS
do
	$CXX -c $f -I ../ $CFLAGS
done

$CXX $OBJS $LIBS -o $OUTFILE $LFLAGS

if [ $CXX = "g++" ]; then
	strip --strip-unneeded $OUTFILE
fi
