#include "templates/game_object.h"
#include "templates/effect.h"
#include "templates/equipment.h"
#include "material.h"

const std::string& GetDescription(const std::string& classname);
const std::string& GetUnitImage(const std::string& classname);
const std::string& GetUnitModel(const std::string& classname);
const std::string& GetUnitName(const std::string& classname);

building_ptr tohuCreateTownCenter(faction_ptr f);
building_ptr tohuCreateSettlement(faction_ptr f);
building_ptr tohuCreatePowerPlant(faction_ptr f);
building_ptr tohuCreateFactoryS(faction_ptr f);
building_ptr tohuCreateFactoryM(faction_ptr f);
building_ptr tohuCreateFactoryL(faction_ptr f);
building_ptr tohuCreateLaboratory(faction_ptr f);
building_ptr tohuCreateTower(faction_ptr f);
building_ptr tohuCreateCastle(faction_ptr f);

unit_ptr tohuCreateWorker(faction_ptr f);
unit_ptr tohuCreateSoldier1(faction_ptr f);
unit_ptr tohuCreateSoldier2(faction_ptr f);
unit_ptr tohuCreateSoldier3(faction_ptr f);
unit_ptr tohuCreateArmor1(faction_ptr f);
unit_ptr tohuCreateArmor2(faction_ptr f);
unit_ptr tohuCreateArmor3(faction_ptr f);
unit_ptr tohuCreateLaser1(faction_ptr f);
unit_ptr tohuCreateLaser2(faction_ptr f);
unit_ptr tohuCreateLaser3(faction_ptr f);
unit_ptr tohuCreateBomber1(faction_ptr f);
unit_ptr tohuCreateEmperor(faction_ptr f);

unit_ptr tohuCreateHealer(faction_ptr f);
unit_ptr tohuCreateArbalest(faction_ptr f);
unit_ptr tohuCreateTransporter(faction_ptr f);
unit_ptr tohuCreateMine(faction_ptr f);
unit_ptr tohuCreateAssasin(faction_ptr f);
unit_ptr tohuCreateDetector(faction_ptr f);

unit_ptr tohuCreateDestroyer(faction_ptr f);
unit_ptr tohuCreateCruiser(faction_ptr f);
unit_ptr tohuCreateMovilFort(faction_ptr f);

weapon_ptr tohuCreateGun1();
weapon_ptr tohuCreateEnergyShot1();
weapon_ptr tohuCreateSnake1();
weapon_ptr tohuCreateBomb1();
